Option Explicit On
Option Strict On


'//////////////////////////////////////////////////////////////
'OpenCVLibTv ColorSpace
'E摜t@Cǂݍ݁Aqfa/gru/gkr̊ev[\܂B
'//////////////////////////////////////////////////////////////

Imports OpenCVLib
Imports System.Runtime.InteropServices

Public Class Form1

    '萔
    Private Const WINDOWNAME As String = "ViewImage"

    'vCx[gϐ
    Private mSrcImgPtr As IntPtr    '\[XC[W

    'tH[[h
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        '\pEBhE
        cvNamedWindow(WINDOWNAME, CV_WINDOW_AUTOSIZE)

        'OpenCṼTv摜\
        FileLoad(CvUtility.GetDLLPath() + "\samples\c\lena.jpg")
        ViewImage()

    End Sub

    'tH[N[Y
    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing

        '\EBhE̔j
        cvDestroyWindow(WINDOWNAME)

        'C[W̔j
        cvReleaseImage(mSrcImgPtr)
        
    End Sub

    't@CI{^
    Private Sub Btn_File_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_File.Click

        't@CI
        Dim dlg As New OpenFileDialog
        dlg.FileName = lbl_File.Text
        If dlg.ShowDialog <> Windows.Forms.DialogResult.OK Then
            'LZ
            Exit Sub
        End If

        'Ǎ
        FileLoad(dlg.FileName)

        '\
        ViewImage()

    End Sub

    '摜t@Cǂݍ
    Private Sub FileLoad(ByVal Filename As String)

        't@Cxɕ\
        lbl_File.Text = Filename

        '݂̃C[Wj
        cvReleaseImage(mSrcImgPtr)

        '摜Ǎ
        mSrcImgPtr = cvLoadImage(Filename, CV_LOAD_IMAGE_UNCHANGED)

    End Sub

    '摜̕\
    Private Sub ViewImage()

        '摜\
        If Rdo_SRC.Checked Then
            cvShowImage(WINDOWNAME, mSrcImgPtr)
            Exit Sub
        End If

        'C[WTCY擾
        Dim imgdata As IplImage
        imgdata = CType(Marshal.PtrToStructure(mSrcImgPtr, GetType(IplImage)), IplImage)
        Dim sz As CvSize
        sz.width = imgdata.width
        sz.height = imgdata.height

        '\pC[Ẅ쐬
        Dim cnvimgptr As IntPtr = cvCreateImage(sz, IPL_DEPTH_8U, 3)
        Dim imgptr As IntPtr = cvCreateImage(sz, IPL_DEPTH_8U, 1)

        'C[W쐬
        Select Case True
            Case Rdo_RGB_B.Checked
                cvSplit(mSrcImgPtr, imgptr, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero)

            Case Rdo_RGB_G.Checked
                cvSplit(mSrcImgPtr, IntPtr.Zero, imgptr, IntPtr.Zero, IntPtr.Zero)

            Case Rdo_RGB_R.Checked
                cvSplit(mSrcImgPtr, IntPtr.Zero, IntPtr.Zero, imgptr, IntPtr.Zero)

            Case Rdo_HSV_H.Checked
                cvCvtColor(mSrcImgPtr, cnvimgptr, CV_BGR2HSV)
                cvSplit(cnvimgptr, imgptr, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero)

            Case Rdo_HSV_S.Checked
                cvCvtColor(mSrcImgPtr, cnvimgptr, CV_BGR2HSV)
                cvSplit(cnvimgptr, IntPtr.Zero, imgptr, IntPtr.Zero, IntPtr.Zero)

            Case Rdo_HSV_V.Checked
                cvCvtColor(mSrcImgPtr, cnvimgptr, CV_BGR2HSV)
                cvSplit(cnvimgptr, IntPtr.Zero, IntPtr.Zero, imgptr, IntPtr.Zero)

            Case Rdo_HLS_H.Checked
                cvCvtColor(mSrcImgPtr, cnvimgptr, CV_BGR2HLS)
                cvSplit(cnvimgptr, imgptr, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero)

            Case Rdo_HLS_L.Checked
                cvCvtColor(mSrcImgPtr, cnvimgptr, CV_BGR2HLS)
                cvSplit(cnvimgptr, IntPtr.Zero, imgptr, IntPtr.Zero, IntPtr.Zero)

            Case Rdo_HLS_S.Checked
                cvCvtColor(mSrcImgPtr, cnvimgptr, CV_BGR2HLS)
                cvSplit(cnvimgptr, IntPtr.Zero, IntPtr.Zero, imgptr, IntPtr.Zero)

        End Select

        '\
        cvShowImage(WINDOWNAME, imgptr)

        'j
        cvReleaseImage(cnvimgptr)
        cvReleaseImage(imgptr)

    End Sub


    '\C[WύX
    Private Sub Rdo_SRC_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) _
        Handles Rdo_SRC.CheckedChanged, _
                Rdo_RGB_R.CheckedChanged, Rdo_RGB_G.CheckedChanged, Rdo_RGB_B.CheckedChanged, _
                Rdo_HSV_H.CheckedChanged, Rdo_HSV_S.CheckedChanged, Rdo_HSV_V.CheckedChanged, _
                Rdo_HLS_H.CheckedChanged, Rdo_HLS_L.CheckedChanged, Rdo_HLS_S.CheckedChanged

        '\
        ViewImage()

    End Sub


End Class
