Option Explicit On
Option Strict On

Imports OpenCVLib
Imports System.drawing
Imports System.Runtime.InteropServices


'//////////////////////////////////////////////////////////
'OpenCV[eBeBW[
''' <summary>
''' OpenCVgꍇɕ֗Ȋ֐/API`Z߂W[łB
''' </summary>
''' <remarks></remarks>
Public Module CvUtility

    '//////////////////////////////////////////////////////////
#Region "ėpAPI`"

    Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (ByVal hpvDest As IntPtr, ByVal hpvSource As IntPtr, ByVal Count As Integer)
    Public Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As IntPtr
    Public Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As IntPtr) As Integer
    Public Declare Function GetModuleFileName Lib "kernel32" Alias "GetModuleFileNameA" (ByVal hModule As IntPtr, ByVal lpFileName As String, ByVal nSize As Integer) As Integer

#End Region

    '//////////////////////////////////////////////////////////
    '[eBeB֐S

#Region "|C^֘A"

    ''' <summary>
    ''' A}l[Ẅ̃f[^}l[ẄɃRs[܂B
    ''' ̊֐̓f[^^ϊȗׂ̊֐łB
    ''' </summary>
    ''' <typeparam name="T">f[^^</typeparam>
    ''' <param name="Ptr">A}l[Ẅ̃|C^</param>
    ''' <returns>\̃f[^</returns>
    ''' <remarks></remarks>
    Public Function PtrToStructure(Of T)(ByVal Ptr As IntPtr) As T
        Return CType(Marshal.PtrToStructure(Ptr, GetType(T)), T)
    End Function
    Public Function PtrToStructure(Of T)(ByVal Ptr As IntPtr, ByVal Offset As Integer) As T
        Dim pp As IntPtr = CType(Ptr.ToInt32 + Offset, IntPtr)
        Return CType(Marshal.PtrToStructure(pp, GetType(T)), T)
    End Function

    ''' <summary>
    ''' }l[Ẅ̃f[^(\̃f[^)A}l[ẄɃRs[܂B
    ''' </summary>
    ''' <typeparam name="T">f[^^</typeparam>
    ''' <param name="Data">Rs[̍\̃f[^</param>
    ''' <param name="Ptr">A}l[Ẅ̃|C^</param>
    ''' <remarks></remarks>
    Public Sub StructureToPtr(Of T)(ByVal Data As T, ByVal Ptr As IntPtr)
        Marshal.StructureToPtr(Data, Ptr, True)
    End Sub

    ''' <summary>
    ''' A}l[ẄɃmۂ܂B
    ''' </summary>
    ''' <typeparam name="T">f[^^</typeparam>
    ''' <param name="Count">f[^</param>
    ''' <returns>mۂA}l[Ẅւ̃|C^</returns>
    ''' <remarks></remarks>
    Public Function Alloc(Of T)(Optional ByVal Count As Integer = 1) As IntPtr

        'ꌏ̃TCY擾
        Dim sz As Integer
        sz = Marshal.SizeOf(GetType(T))

        '̈m
        Dim ptr As IntPtr
        ptr = Marshal.AllocHGlobal(sz * Count)

        Return ptr
    End Function

    ''' <summary>
    ''' AllocŊmۂ̈J܂B
    ''' </summary>
    ''' <param name="Ptr">A}l[Ẅւ̃|C^</param>
    ''' <remarks></remarks>
    Public Sub Free(ByVal Ptr As IntPtr)
        If Ptr <> IntPtr.Zero Then
            Marshal.FreeHGlobal(Ptr)
        End If
    End Sub

#End Region

#Region "֘A"

    'DLL̃tpX擾
    ''' <summary>
    ''' DLL̃tpX擾܂B
    ''' DLL̂ȗꍇAOpenCṼCXg[tH_擾܂B
    ''' </summary>
    ''' <param name="DllName">DLL(pXȂÁA΃pXDLLt@C)</param>
    ''' <param name="ForceFree">DLLꍇTrueAȂꍇFalse</param>
    ''' <returns>DLLǂݍ݉\ȏꍇDLL̃tpXADLLȂꍇ󕶎</returns>
    ''' <remarks>
    ''' ̊֐OpenCṼTvf[^gꍇɎgp邱Ƃz肵Ă܂B
    ''' DLLp\̏ꍇAw肳ꂽDLL͈UvZXɃ[h(LoadLibrary)܂B
    ''' ForceFreeTruȅꍇApX擾ɉ(FreeLibrary)܂B
    ''' </remarks>
    Public Function GetDLLPath(ByVal DllName As String, Optional ByVal ForceFree As Boolean = False) As String
        Const MAXPATH As Integer = 512

        'DLLǂݍ
        Dim hMod As IntPtr = LoadLibrary(DllName)
        If hMod = IntPtr.Zero Then
            'DLLȂ
            Return ""
        End If

        'tpX擾
        Dim buff As String = New String(Chr(0), MAXPATH)
        GetModuleFileName(hMod, buff, MAXPATH - 1)
        buff = buff.Replace(Chr(0), " ")
        buff = buff.Trim

        'DLL
        If ForceFree Then
            FreeLibrary(hMod)
        End If

        Return buff
    End Function
    ''' <summary>
    ''' OpenCṼCXg[tH_̃pX擾܂B
    ''' </summary>
    ''' <returns>OpenCṼCXg[tH_pX</returns>
    ''' <remarks>
    ''' DLLp\̏ꍇAuCVxxx.DLLvUvZXɃ[h܂B
    ''' </remarks>
    Public Function GetDLLPath() As String

        Try
            'CVxxx.DLL̃pX擾
            Dim cvpath As String = GetDLLPath(OpenCVInformation.Cv)

            'e̐etH_擾
            Dim pp As New System.IO.FileInfo(cvpath)
            Return pp.Directory.Parent.FullName

        Catch ex As Exception
            's

        End Try

        'Ȃ
        Return ""
    End Function

#End Region

#Region "C[W֘A"

    ''' <summary>
    ''' IplImage|C^C[Wf[^}l[ẄɃRs[܂B
    ''' </summary>
    ''' <param name="ImagePtr">IplImage|C^</param>
    ''' <returns>IplImage\</returns>
    ''' <remarks>
    ''' ߂l̓|C^C[Wf[^̃Rs[łB
    ''' QƂ͖肠܂񂪁AXVꍇӂĉB
    ''' A}l[ẄXVꍇ́ARs[XVA
    ''' Marshal.StructureToPtr( img, ImagePtr, False )
    ''' ̏sKv܂B
    ''' </remarks>
    Public Function GetIplImage(ByVal ImagePtr As IntPtr) As IplImage
        Return CvUtility.PtrToStructure(Of IplImage)(ImagePtr)
    End Function

    ''' <summary>
    ''' IplImage|C^C[W̃TCY擾܂B
    ''' </summary>
    ''' <param name="ImagePtr">IplImage|C^</param>
    ''' <returns>C[W̑傫(CvSize^)</returns>
    ''' <remarks>̊֐̓TvpłBʂŎpIł͂܂B</remarks>
    Public Function GetIplImageSize(ByVal ImagePtr As IntPtr) As CvSize
        Dim img As IplImage = CvUtility.PtrToStructure(Of IplImage)(ImagePtr)
        Return New CvSize(img.width, img.height)
    End Function

    ''' <summary>
    ''' IplImage|C^C[W̃f[^i[擾܂B
    ''' </summary>
    ''' <param name="ImagePtr">IplImage|C^</param>
    ''' <returns>f[^i[ 0:Top-Down 1:Bottom-Up</returns>
    ''' <remarks>̊֐̓TvpłBʂŎpIł͂܂B</remarks>
    Public Function GetIplImageOrigin(ByVal ImagePtr As IntPtr) As Integer
        Dim img As IplImage = CvUtility.PtrToStructure(Of IplImage)(ImagePtr)
        Return img.origin
    End Function

    ''' <summary>
    ''' IplImage|C^C[W̃f[^i[ݒ肵܂B
    ''' </summary>
    ''' <param name="ImagePtr">IplImage|C^</param>
    ''' <param name="origin">f[^i[ 0:Top-Down 1:Bottom-Up</param>
    ''' <remarks>̊֐̓TvpłBʂŎpIł͂܂B</remarks>
    Public Sub SetIplImageOrigin(ByVal ImagePtr As IntPtr, ByVal origin As Integer)
        Dim img As IplImage = CvUtility.PtrToStructure(Of IplImage)(ImagePtr)
        img.origin = origin
        Marshal.StructureToPtr(img, ImagePtr, False)
    End Sub

    ''' <summary>
    ''' IplImage|C^C[W̃`l擾܂B
    ''' </summary>
    ''' <param name="ImagePtr">IplImage|C^</param>
    ''' <returns>`l</returns>
    ''' <remarks>̊֐̓TvpłBʂŎpIł͂܂B</remarks>
    Public Function GetIplImageChannels(ByVal ImagePtr As IntPtr) As Integer
        Dim img As IplImage = CvUtility.PtrToStructure(Of IplImage)(ImagePtr)
        Return img.nChannels
    End Function

    ''' <summary>
    ''' IplImage|C^C[W̃f[^i[̈|C^擾܂B
    ''' </summary>
    ''' <param name="ImagePtr">IplImage|C^</param>
    ''' <returns>f[^i[̈|C^</returns>
    ''' <remarks>̊֐̓TvpłBʂŎpIł͂܂B</remarks>
    Public Function GetIplImageDataPtr(ByVal ImagePtr As IntPtr) As IntPtr
        Dim img As IplImage = CvUtility.PtrToStructure(Of IplImage)(ImagePtr)
        Return img.imageData
    End Function

#End Region

End Module
